
Ruby - Bug #3316

Kernel#caller returns nil as well

05/19/2010 12:49 PM - no6v (Nobuhiro IMAI)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: - Backport:  

Description

=begin

[ruby-dev:41330] の件ですが、トップレベル云々は置いといて、

nil が返ることもあるというのを RDoc に書いてみました。

trunk や branches/ruby_1_9_2 にそのまま当たると思います。

=end

History

#1 - 05/19/2010 08:05 PM - mame (Yusuke Endoh)

=begin

遠藤です。

2010年5月19日12:49 Nobuhiro IMAI redmine@ruby-lang.org:

[ruby-dev:41330] の件ですが、トップレベル云々は置いといて、

nil が返ることもあるというのを RDoc に書いてみました。

 反応が遅くてすみません。

見たところ r21932 で入った変更のようですが、ChangeLog によると

最適化かリファクタリングを意図したもののようで、挙動変更自体は

意図していなかったものと思います。

トップレベルでは空配列を返すように修正しておきます。

diff --git a/vm_eval.c b/vm_eval.c

index 2bf640d..d1e6352 100644

--- a/vm_eval.c

+++ b/vm_eval.c

@@ -1562,7 +1562,7 @@ rb_catch_obj(VALUE tag, VALUE (*func)(), VALUE data)

static VALUE

rb_f_caller(int argc, VALUE *argv)

{

VALUE level;

VALUE level, ary;

int lev;

rb_scan_args(argc, argv, "01", &level);

@@ -1574,7 +1574,9 @@ rb_f_caller(int argc, VALUE *argv)

if (lev < 0)

rb_raise(rb_eArgError, "negative level (%d)", lev);

return vm_backtrace(GET_THREAD(), lev);

ary = vm_backtrace(GET_THREAD(), lev);

if (NIL_P(ary)) ary = rb_ary_new();

return ary;

}

static int

--
=end

#2 - 05/19/2010 08:27 PM - mame (Yusuke Endoh)

- Status changed from Open to Closed

- % Done changed from 0 to 100

=begin

This issue was solved with changeset r27895.

Nobuhiro, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

=end

#3 - 05/20/2010 04:47 AM - no6v (Nobuhiro IMAI)

=begin

いまいです。

From: Yusuke ENDOH <mame_at_tsg.ne.jp>

Date: Wed, 19 May 2010 20:05:45 +0900

見たところ r21932 で入った変更のようですが、ChangeLog によると

最適化かリファクタリングを意図したもののようで、挙動変更自体は

意図していなかったものと思います。

トップレベルでは空配列を返すように修正しておきます。

 ありがとうございます。

が、これだと、caller(0) で返る配列のサイズを越える数を引数として渡して

も空配列が返るようになってしまっているようです。

$ ruby1.8 -ve 'p [caller(0), caller(1), caller(2)]'

ruby 1.8.8dev (2010-05-17 revision 26358) [i686-linux]

[["-e:1"], [], nil]

^^^

$ ruby1.9 -ve 'p [caller(0), caller(1), caller(2)]

'ruby 1.9.3dev (2010-05-20 trunk 27911) [i686-linux]

[["-e:1:in `'"], [], []]

^^

caller(0)[start..-1] ということなのかな。

--

Nobuhiro IMAI nov@yo.rim.or.jp

Key fingerprint = F39E D552 545D 7C64 D690  F644 5A15 746C BD8E 7106

=end

#4 - 05/20/2010 09:58 PM - mame (Yusuke Endoh)

=begin

遠藤です。

2010年5月20日4:47 Nobuhiro IMAI nov@yo.rim.or.jp:

が、これだと、caller(0) で返る配列のサイズを越える数を引数として渡して

も空配列が返るようになってしまっているようです。

 ぐああ、問題を誤解していました。nil が帰ることがあるのは元からなんですね。

以下のパッチで再挑戦します。それから頂いたパッチは取り込んでおきます。

diff --git a/vm.c b/vm.c

index 084c8c8..ac1d8ed 100644

--- a/vm.c

+++ b/vm.c

@@ -706,19 +706,20 @@ rb_vm_get_sourceline(const rb_control_frame_t *cfp)

}

static int
-vm_backtrace_each(rb_thread_t *th, int lev, rb_backtrace_iter_func

*iter, void *arg)

+vm_backtrace_each(rb_thread_t *th, int lev, void (*init)(void *),

rb_backtrace_iter_func *iter, void *arg)

{

const rb_control_frame_t *limit_cfp = th->cfp;

const rb_control_frame_t *cfp = (void *)(th->stack + th->stack_size);

VALUE file = Qnil;

VALUE file = Qnil, *aryp = arg;

int line_no = 0;

cfp -= 2;

while (lev-- >= 0) {

if (++limit_cfp >= cfp) {

if (++limit_cfp > cfp) {

return FALSE;

}

}

if (init) (*init)(arg);

limit_cfp = RUBY_VM_NEXT_CONTROL_FRAME(limit_cfp);

if (th->vm->progname) file = th->vm->progname;

while (cfp > limit_cfp) {

@@ -747,15 +748,19 @@ vm_backtrace_each(rb_thread_t *th, int lev,

rb_backtrace_iter_func *iter, void *

return TRUE;

}

+static void

+vm_backtrace_alloc(void *arg)

+{

VALUE *aryp = arg;

*aryp = rb_ary_new();

+}

static int

vm_backtrace_push(void *arg, VALUE file, int line_no, VALUE name)

{

VALUE *aryp = arg;

VALUE bt;

if (!*aryp) {

*aryp = rb_ary_new();

}

bt = rb_enc_sprintf(rb_enc_compatible(file, name), "%s:%d:in `%s'",

RSTRING_PTR(file), line_no, RSTRING_PTR(name));

rb_ary_push(*aryp, bt);

@@ -770,7 +775,7 @@ vm_backtrace(rb_thread_t *th, int lev)

if (lev < 0) {

ary = rb_ary_new();

}

vm_backtrace_each(th, lev, vm_backtrace_push, &ary);

vm_backtrace_each(th, lev, vm_backtrace_alloc, vm_backtrace_push, &ary);

if (!ary) return Qnil;

return rb_ary_reverse(ary);

}

diff --git a/vm_eval.c b/vm_eval.c

index d1e6352..b854efc 100644

--- a/vm_eval.c

+++ b/vm_eval.c

@@ -16,7 +16,7 @@ static inline VALUE rb_vm_set_finish_env(rb_thread_t * th);

static inline VALUE vm_yield_with_cref(rb_thread_t *th, int argc,

const VALUE *argv, const NODE *cref);

static inline VALUE vm_yield(rb_thread_t *th, int argc, const VALUE *argv);

static inline VALUE vm_backtrace(rb_thread_t *th, int lev);

-static int vm_backtrace_each(rb_thread_t *th, int lev,

rb_backtrace_iter_func *iter, void *arg);

+static int vm_backtrace_each(rb_thread_t *th, int lev, void
(*init)(void *), rb_backtrace_iter_func *iter, void *arg);

static NODE *vm_cref_push(rb_thread_t *th, VALUE klass, int noex,

rb_block_t *blockptr);

static VALUE vm_exec(rb_thread_t *th);

static void vm_set_eval_stack(rb_thread_t * th, VALUE iseqval, const

NODE *cref);

@@ -1574,9 +1574,7 @@ rb_f_caller(int argc, VALUE *argv)

if (lev < 0)

rb_raise(rb_eArgError, "negative level (%d)", lev);

ary = vm_backtrace(GET_THREAD(), lev);

if (NIL_P(ary)) ary = rb_ary_new();

return ary;

return vm_backtrace(GET_THREAD(), lev);

}

static int

@@ -1598,7 +1596,7 @@ print_backtrace(void *arg, VALUE file, int line,

VALUE method)

void

rb_backtrace(void)

{

vm_backtrace_each(GET_THREAD(), -1, print_backtrace, stderr);

vm_backtrace_each(GET_THREAD(), -1, NULL, print_backtrace, stderr);

}

VALUE

@@ -1629,7 +1627,7 @@ rb_thread_backtrace(VALUE thval)

int

rb_backtrace_each(rb_backtrace_iter_func *iter, void *arg)

{

return vm_backtrace_each(GET_THREAD(), -1, iter, arg);

return vm_backtrace_each(GET_THREAD(), -1, NULL, iter, arg);

}

/*

--

Yusuke Endoh mame@tsg.ne.jp

=end

#5 - 05/22/2010 12:59 AM - no6v (Nobuhiro IMAI)

=begin

いまいです。

From: Yusuke ENDOH <mame_at_tsg.ne.jp>

Date: Thu, 20 May 2010 21:58:42 +0900

遠藤です。

2010年5月20日4:47 Nobuhiro IMAI nov@yo.rim.or.jp:

が、これだと、caller(0) で返る配列のサイズを越える数を引数として渡して

も空配列が返るようになってしまっているようです。

 ぐああ、問題を誤解していました。nil が帰ることがあるのは元からなんですね。

以下のパッチで再挑戦します。それから頂いたパッチは取り込んでおきます。

 トップレベル云々の話で混乱させてしまったかもしれません。ごめんなさい。

これで、1.8 と同じ挙動になっていると思います。という訳で、せっかくパッ

チを取り込んでいただいたのに、RDoc の方が間違いになってしまいました。

以下のパッチで正しい記述になると思います。ついでに、

他の場所に合わせて s/Array/array/

実際の出力に合わせて in `' を追加
caller(4) を修正、caller(5) を追加

という変更を加えています。合わせて取捨選択してください。

Nobuhiro IMAI nov@yo.rim.or.jp

Key fingerprint = F39E D552 545D 7C64 D690  F644 5A15 746C BD8E 7106

diff --git a/vm_eval.c b/vm_eval.c

index cff05a0..e609ca0 100644

--- a/vm_eval.c

+++ b/vm_eval.c

@@ -1536,7 +1536,7 @@ rb_catch_obj(VALUE tag, VALUE (*func)(), VALUE data)

/*

call-seq:

caller(start=1)    -> Array or nil

caller(start=1)    -> array or nil

Returns the current execution stack---an array containing strings in

the form <em>file:line</em>'' or file:line: in

@@ -1544,7 +1544,7 @@ rb_catch_obj(VALUE tag, VALUE (*func)(), VALUE data)

determines the number of initial stack entries to omit from the

result.

Returns +nil+ if start is greater than or equal to the size of

Returns +nil+ if start is greater than the size of

current execution stack.

def a(skip)

@@ -1556,11 +1556,12 @@ rb_catch_obj(VALUE tag, VALUE (*func)(), VALUE data)

def c(skip)

  b(skip)

end

c(0)   #=> ["prog:2:in `a'", "prog:5:in `b'", "prog:8:in `c'", "prog:10"]

c(1)   #=> ["prog:5:in `b'", "prog:8:in `c'", "prog:11"]

c(2)   #=> ["prog:8:in `c'", "prog:12"]

c(3)   #=> ["prog:13"]

c(4)   #=> nil

c(0)   #=> ["prog:2:in `a'", "prog:5:in `b'", "prog:8:in `c'", "prog:10:in `<main>'"]

c(1)   #=> ["prog:5:in `b'", "prog:8:in `c'", "prog:11:in `<main>'"]

c(2)   #=> ["prog:8:in `c'", "prog:12:in `<main>'"]

c(3)   #=> ["prog:13:in `<main>'"]

c(4)   #=> []

c(5)   #=> nil

*/

static VALUE
=end

#6 - 05/25/2010 01:44 AM - mame (Yusuke Endoh)

=begin

遠藤です。

2010年5月22日0:59 Nobuhiro IMAI nov@yo.rim.or.jp:

これで、1.8 と同じ挙動になっていると思います。という訳で、せっかくパッ

チを取り込んでいただいたのに、RDoc の方が間違いになってしまいました。

 うああ。

以下のパッチで正しい記述になると思います。ついでに、

他の場所に合わせて s/Array/array/

実際の出力に合わせて in `' を追加

caller(4) を修正、caller(5) を追加

という変更を加えています。合わせて取捨選択してください。

 ありがとうございます。ごっそり取り込みます。

--

Yusuke Endoh mame@tsg.ne.jp

=end

Files

caller-rdoc.patch 993 Bytes 05/19/2010 no6v (Nobuhiro IMAI)
